import { IPublicTypeEngineOptions, IPublicApiPlugins } from '@gant-lowcode/lowcode-types';
import { PluginPreference } from '@gant-lowcode/lowcode-designer';
import './modules/live-editing';
import * as classes from './modules/classes';
import { Hotkey, Setters, Material, Event, Common, Logger, Canvas, Workspace, CommonUI, Command } from '@gant-lowcode/lowcode-shell';
export * from './modules/skeleton-types';
export * from './modules/designer-types';
export * from './modules/lowcode-types';
declare const config: import("@gant-lowcode/lowcode-types").IPublicModelEngineConfig, plugins: IPublicApiPlugins;
declare const skeleton: classes.Skeleton, project: classes.Project, setters: Setters, material: Material, event: Event, logger: Logger, hotkey: Hotkey, common: Common, workspace: Workspace, canvas: Canvas, commonUI: CommonUI, command: Command;
export { skeleton, plugins, project, setters, material, config, event, logger, hotkey, common, workspace, canvas, commonUI, command, };
export declare const isOpenSource = true;
export declare const __SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED: {
    symbols: {
        projectSymbol: symbol;
        documentSymbol: symbol;
        nodeSymbol: symbol;
        nodeChildrenSymbol: symbol;
        skeletonSymbol: symbol;
        editorSymbol: symbol;
        designerSymbol: symbol;
        settingPropEntrySymbol: symbol;
        settingTopEntrySymbol: symbol;
        designerCabinSymbol: symbol;
        editorCabinSymbol: symbol;
        skeletonCabinSymbol: symbol;
        propSymbol: symbol;
        simulatorHostSymbol: symbol;
        skeletonItemSymbol: symbol;
        simulatorRenderSymbol: symbol;
    };
    classes: typeof classes;
};
export declare const version: any;
export declare function init(container?: HTMLElement, options?: IPublicTypeEngineOptions, pluginPreference?: PluginPreference): Promise<void>;
export declare function destroy(): Promise<void>;
